# osdn-client

OSDNClient - the Ruby gem for the OSDN REST API v0 beta

OSDN REST API. Currently this API is experimental release. Pelase refer documentation on https://osdn.net/projects/osdn-codes/wiki/APIGuide and you can get client libraries from https://osdn.net/projects/osdn-codes/releases/p14859 . 

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 0.0.20161031
- Package version: 0.0.20161031
- Build date: 2016-11-01T15:52:47.488+09:00
- Build package: class io.swagger.codegen.languages.RubyClientCodegen
For more information, please visit [https://osdn.net/projects/osdn-codes/wiki/APIGuide](https://osdn.net/projects/osdn-codes/wiki/APIGuide)

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build osdn-client.gemspec
```

Then either install the gem locally:

```shell
gem install ./osdn-client-0.0.20161031.gem
```
(for development, run `gem install --dev ./osdn-client-0.0.20161031.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'osdn-client', '~> 0.0.20161031'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/OSDN/Client, then add the following in the Gemfile:

    gem 'osdn-client', :git => 'https://github.com/OSDN/Client.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'osdn-client'

# Setup authorization
OSDNClient.configure do |config|
  # Configure OAuth2 access token for authorization: oauth2-code
  config.access_token = 'YOUR ACCESS TOKEN'

  # Configure OAuth2 access token for authorization: oauth2-implicit
  config.access_token = 'YOUR ACCESS TOKEN'
end

api_instance = OSDNClient::DefaultApi.new

begin
  result = api_instance.ping
  p result
rescue OSDNClient::ApiError => e
  puts "Exception when calling DefaultApi->ping: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://osdn.net/api/v0*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OSDNClient::DefaultApi* | [**ping**](docs/DefaultApi.md#ping) | **GET** /ping | 
*OSDNClient::DefaultApi* | [**token**](docs/DefaultApi.md#token) | **POST** /token | 
*OSDNClient::ProjectApi* | [**create_news**](docs/ProjectApi.md#create_news) | **POST** /news | 
*OSDNClient::ProjectApi* | [**create_news_0**](docs/ProjectApi.md#create_news_0) | **POST** /project/{id_or_name}/news | 
*OSDNClient::ProjectApi* | [**create_package**](docs/ProjectApi.md#create_package) | **POST** /project/{id_or_name}/frs | 
*OSDNClient::ProjectApi* | [**create_project_bzr**](docs/ProjectApi.md#create_project_bzr) | **POST** /project/{id_or_name}/bzr | 
*OSDNClient::ProjectApi* | [**create_project_git**](docs/ProjectApi.md#create_project_git) | **POST** /project/{id_or_name}/git | 
*OSDNClient::ProjectApi* | [**create_project_git_hook**](docs/ProjectApi.md#create_project_git_hook) | **POST** /project/{id_or_name}/git/{repo_id}/hooks | 
*OSDNClient::ProjectApi* | [**create_project_hg**](docs/ProjectApi.md#create_project_hg) | **POST** /project/{id_or_name}/hg | 
*OSDNClient::ProjectApi* | [**create_release**](docs/ProjectApi.md#create_release) | **POST** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectApi* | [**create_release_file**](docs/ProjectApi.md#create_release_file) | **POST** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectApi* | [**delete_news**](docs/ProjectApi.md#delete_news) | **DELETE** /news/{news_id} | 
*OSDNClient::ProjectApi* | [**delete_news_0**](docs/ProjectApi.md#delete_news_0) | **DELETE** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectApi* | [**delete_package**](docs/ProjectApi.md#delete_package) | **DELETE** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectApi* | [**delete_project_git_hook**](docs/ProjectApi.md#delete_project_git_hook) | **DELETE** /project/{id_or_name}/git/{repo_id}/hooks/{hook_id} | 
*OSDNClient::ProjectApi* | [**delete_release**](docs/ProjectApi.md#delete_release) | **DELETE** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectApi* | [**delete_release_file**](docs/ProjectApi.md#delete_release_file) | **DELETE** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectApi* | [**disable_project_bzr**](docs/ProjectApi.md#disable_project_bzr) | **DELETE** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectApi* | [**disable_project_git**](docs/ProjectApi.md#disable_project_git) | **DELETE** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectApi* | [**disable_project_hg**](docs/ProjectApi.md#disable_project_hg) | **DELETE** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::ProjectApi* | [**draft_release**](docs/ProjectApi.md#draft_release) | **GET** /project/{id_or_name}/frs/{package_id}/draft | 
*OSDNClient::ProjectApi* | [**get_news**](docs/ProjectApi.md#get_news) | **GET** /news/{news_id} | 
*OSDNClient::ProjectApi* | [**get_news_0**](docs/ProjectApi.md#get_news_0) | **GET** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectApi* | [**get_package**](docs/ProjectApi.md#get_package) | **GET** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectApi* | [**get_project**](docs/ProjectApi.md#get_project) | **GET** /project/{id_or_name} | 
*OSDNClient::ProjectApi* | [**get_project_admin_projectweb**](docs/ProjectApi.md#get_project_admin_projectweb) | **GET** /project/{id_or_name}/admin/project_web | 
*OSDNClient::ProjectApi* | [**get_project_bzr**](docs/ProjectApi.md#get_project_bzr) | **GET** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectApi* | [**get_project_git**](docs/ProjectApi.md#get_project_git) | **GET** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectApi* | [**get_project_git_hook**](docs/ProjectApi.md#get_project_git_hook) | **GET** /project/{id_or_name}/git/{repo_id}/hooks/{hook_id} | 
*OSDNClient::ProjectApi* | [**get_project_hg**](docs/ProjectApi.md#get_project_hg) | **GET** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::ProjectApi* | [**get_project_profile**](docs/ProjectApi.md#get_project_profile) | **GET** /project/{id_or_name}/admin/profile | 
*OSDNClient::ProjectApi* | [**get_project_svn**](docs/ProjectApi.md#get_project_svn) | **GET** /project/{id_or_name}/svn | 
*OSDNClient::ProjectApi* | [**get_project_tools**](docs/ProjectApi.md#get_project_tools) | **GET** /project/{id_or_name}/admin/tools | 
*OSDNClient::ProjectApi* | [**get_release**](docs/ProjectApi.md#get_release) | **GET** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectApi* | [**get_release_file**](docs/ProjectApi.md#get_release_file) | **GET** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectApi* | [**list_news**](docs/ProjectApi.md#list_news) | **GET** /news | 
*OSDNClient::ProjectApi* | [**list_news_0**](docs/ProjectApi.md#list_news_0) | **GET** /project/{id_or_name}/news | 
*OSDNClient::ProjectApi* | [**list_packages**](docs/ProjectApi.md#list_packages) | **GET** /project/{id_or_name}/frs | 
*OSDNClient::ProjectApi* | [**list_project_bzr**](docs/ProjectApi.md#list_project_bzr) | **GET** /project/{id_or_name}/bzr | 
*OSDNClient::ProjectApi* | [**list_project_git**](docs/ProjectApi.md#list_project_git) | **GET** /project/{id_or_name}/git | 
*OSDNClient::ProjectApi* | [**list_project_git_hook**](docs/ProjectApi.md#list_project_git_hook) | **GET** /project/{id_or_name}/git/{repo_id}/hooks | 
*OSDNClient::ProjectApi* | [**list_project_hg**](docs/ProjectApi.md#list_project_hg) | **GET** /project/{id_or_name}/hg | 
*OSDNClient::ProjectApi* | [**update_news**](docs/ProjectApi.md#update_news) | **PATCH** /news/{news_id} | 
*OSDNClient::ProjectApi* | [**update_news_0**](docs/ProjectApi.md#update_news_0) | **PATCH** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectApi* | [**update_package**](docs/ProjectApi.md#update_package) | **PATCH** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectApi* | [**update_project_admin_projectweb**](docs/ProjectApi.md#update_project_admin_projectweb) | **PATCH** /project/{id_or_name}/admin/project_web | 
*OSDNClient::ProjectApi* | [**update_project_bzr**](docs/ProjectApi.md#update_project_bzr) | **PATCH** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectApi* | [**update_project_git**](docs/ProjectApi.md#update_project_git) | **PATCH** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectApi* | [**update_project_hg**](docs/ProjectApi.md#update_project_hg) | **PATCH** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::ProjectApi* | [**update_project_profile**](docs/ProjectApi.md#update_project_profile) | **PATCH** /project/{id_or_name}/admin/profile | 
*OSDNClient::ProjectApi* | [**update_project_tools**](docs/ProjectApi.md#update_project_tools) | **PATCH** /project/{id_or_name}/admin/tools | 
*OSDNClient::ProjectApi* | [**update_release**](docs/ProjectApi.md#update_release) | **PATCH** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectApi* | [**update_release_file**](docs/ProjectApi.md#update_release_file) | **PATCH** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectFrsApi* | [**create_package**](docs/ProjectFrsApi.md#create_package) | **POST** /project/{id_or_name}/frs | 
*OSDNClient::ProjectFrsApi* | [**create_release**](docs/ProjectFrsApi.md#create_release) | **POST** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectFrsApi* | [**create_release_file**](docs/ProjectFrsApi.md#create_release_file) | **POST** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectFrsApi* | [**delete_package**](docs/ProjectFrsApi.md#delete_package) | **DELETE** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectFrsApi* | [**delete_release**](docs/ProjectFrsApi.md#delete_release) | **DELETE** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectFrsApi* | [**delete_release_file**](docs/ProjectFrsApi.md#delete_release_file) | **DELETE** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectFrsApi* | [**draft_release**](docs/ProjectFrsApi.md#draft_release) | **GET** /project/{id_or_name}/frs/{package_id}/draft | 
*OSDNClient::ProjectFrsApi* | [**get_package**](docs/ProjectFrsApi.md#get_package) | **GET** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectFrsApi* | [**get_release**](docs/ProjectFrsApi.md#get_release) | **GET** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectFrsApi* | [**get_release_file**](docs/ProjectFrsApi.md#get_release_file) | **GET** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectFrsApi* | [**list_packages**](docs/ProjectFrsApi.md#list_packages) | **GET** /project/{id_or_name}/frs | 
*OSDNClient::ProjectFrsApi* | [**update_package**](docs/ProjectFrsApi.md#update_package) | **PATCH** /project/{id_or_name}/frs/{package_id} | 
*OSDNClient::ProjectFrsApi* | [**update_release**](docs/ProjectFrsApi.md#update_release) | **PATCH** /project/{id_or_name}/frs/{package_id}/{release_id} | 
*OSDNClient::ProjectFrsApi* | [**update_release_file**](docs/ProjectFrsApi.md#update_release_file) | **PATCH** /project/{id_or_name}/frs/{package_id}/{release_id}/{file_id} | 
*OSDNClient::ProjectNewsApi* | [**create_news**](docs/ProjectNewsApi.md#create_news) | **POST** /news | 
*OSDNClient::ProjectNewsApi* | [**create_news_0**](docs/ProjectNewsApi.md#create_news_0) | **POST** /project/{id_or_name}/news | 
*OSDNClient::ProjectNewsApi* | [**delete_news**](docs/ProjectNewsApi.md#delete_news) | **DELETE** /news/{news_id} | 
*OSDNClient::ProjectNewsApi* | [**delete_news_0**](docs/ProjectNewsApi.md#delete_news_0) | **DELETE** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectNewsApi* | [**get_news**](docs/ProjectNewsApi.md#get_news) | **GET** /news/{news_id} | 
*OSDNClient::ProjectNewsApi* | [**get_news_0**](docs/ProjectNewsApi.md#get_news_0) | **GET** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectNewsApi* | [**list_news**](docs/ProjectNewsApi.md#list_news) | **GET** /news | 
*OSDNClient::ProjectNewsApi* | [**list_news_0**](docs/ProjectNewsApi.md#list_news_0) | **GET** /project/{id_or_name}/news | 
*OSDNClient::ProjectNewsApi* | [**update_news**](docs/ProjectNewsApi.md#update_news) | **PATCH** /news/{news_id} | 
*OSDNClient::ProjectNewsApi* | [**update_news_0**](docs/ProjectNewsApi.md#update_news_0) | **PATCH** /project/{id_or_name}/news/{news_id} | 
*OSDNClient::ProjectSCMApi* | [**create_project_bzr**](docs/ProjectSCMApi.md#create_project_bzr) | **POST** /project/{id_or_name}/bzr | 
*OSDNClient::ProjectSCMApi* | [**create_project_git**](docs/ProjectSCMApi.md#create_project_git) | **POST** /project/{id_or_name}/git | 
*OSDNClient::ProjectSCMApi* | [**create_project_git_hook**](docs/ProjectSCMApi.md#create_project_git_hook) | **POST** /project/{id_or_name}/git/{repo_id}/hooks | 
*OSDNClient::ProjectSCMApi* | [**create_project_hg**](docs/ProjectSCMApi.md#create_project_hg) | **POST** /project/{id_or_name}/hg | 
*OSDNClient::ProjectSCMApi* | [**delete_project_git_hook**](docs/ProjectSCMApi.md#delete_project_git_hook) | **DELETE** /project/{id_or_name}/git/{repo_id}/hooks/{hook_id} | 
*OSDNClient::ProjectSCMApi* | [**disable_project_bzr**](docs/ProjectSCMApi.md#disable_project_bzr) | **DELETE** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**disable_project_git**](docs/ProjectSCMApi.md#disable_project_git) | **DELETE** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**disable_project_hg**](docs/ProjectSCMApi.md#disable_project_hg) | **DELETE** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**get_project_bzr**](docs/ProjectSCMApi.md#get_project_bzr) | **GET** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**get_project_git**](docs/ProjectSCMApi.md#get_project_git) | **GET** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**get_project_git_hook**](docs/ProjectSCMApi.md#get_project_git_hook) | **GET** /project/{id_or_name}/git/{repo_id}/hooks/{hook_id} | 
*OSDNClient::ProjectSCMApi* | [**get_project_hg**](docs/ProjectSCMApi.md#get_project_hg) | **GET** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**get_project_svn**](docs/ProjectSCMApi.md#get_project_svn) | **GET** /project/{id_or_name}/svn | 
*OSDNClient::ProjectSCMApi* | [**list_project_bzr**](docs/ProjectSCMApi.md#list_project_bzr) | **GET** /project/{id_or_name}/bzr | 
*OSDNClient::ProjectSCMApi* | [**list_project_git**](docs/ProjectSCMApi.md#list_project_git) | **GET** /project/{id_or_name}/git | 
*OSDNClient::ProjectSCMApi* | [**list_project_git_hook**](docs/ProjectSCMApi.md#list_project_git_hook) | **GET** /project/{id_or_name}/git/{repo_id}/hooks | 
*OSDNClient::ProjectSCMApi* | [**list_project_hg**](docs/ProjectSCMApi.md#list_project_hg) | **GET** /project/{id_or_name}/hg | 
*OSDNClient::ProjectSCMApi* | [**update_project_bzr**](docs/ProjectSCMApi.md#update_project_bzr) | **PATCH** /project/{id_or_name}/bzr/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**update_project_git**](docs/ProjectSCMApi.md#update_project_git) | **PATCH** /project/{id_or_name}/git/{repo_id} | 
*OSDNClient::ProjectSCMApi* | [**update_project_hg**](docs/ProjectSCMApi.md#update_project_hg) | **PATCH** /project/{id_or_name}/hg/{repo_id} | 
*OSDNClient::UserApi* | [**get_user**](docs/UserApi.md#get_user) | **GET** /user/{id_or_name} | 


## Documentation for Models

 - [OSDNClient::Group](docs/Group.md)
 - [OSDNClient::GroupProfile](docs/GroupProfile.md)
 - [OSDNClient::GroupToolFlags](docs/GroupToolFlags.md)
 - [OSDNClient::I18NText](docs/I18NText.md)
 - [OSDNClient::News](docs/News.md)
 - [OSDNClient::Package](docs/Package.md)
 - [OSDNClient::Pong](docs/Pong.md)
 - [OSDNClient::ProjectBzr](docs/ProjectBzr.md)
 - [OSDNClient::ProjectGit](docs/ProjectGit.md)
 - [OSDNClient::ProjectHg](docs/ProjectHg.md)
 - [OSDNClient::ProjectSCM](docs/ProjectSCM.md)
 - [OSDNClient::ProjectSCMLastCommit](docs/ProjectSCMLastCommit.md)
 - [OSDNClient::ProjectSvn](docs/ProjectSvn.md)
 - [OSDNClient::ProjectWeb](docs/ProjectWeb.md)
 - [OSDNClient::RelFile](docs/RelFile.md)
 - [OSDNClient::Release](docs/Release.md)
 - [OSDNClient::ScmHook](docs/ScmHook.md)
 - [OSDNClient::SimpleChamber](docs/SimpleChamber.md)
 - [OSDNClient::SimpleGroup](docs/SimpleGroup.md)
 - [OSDNClient::SimpleUser](docs/SimpleUser.md)
 - [OSDNClient::Skill](docs/Skill.md)
 - [OSDNClient::Token](docs/Token.md)
 - [OSDNClient::User](docs/User.md)


## Documentation for Authorization


### oauth2-code

- **Type**: OAuth
- **Flow**: accessCode
- **Authorization URL**: https://osdn.net/account/oauth2ui/authorize
- **Scopes**: 
  - profile: Read basic user profile
  - group: read access to group data
  - group_write: write access to group data
  - chamber: read access to chamber data
  - chamber_write: write access to chamber data

### oauth2-implicit

- **Type**: OAuth
- **Flow**: implicit
- **Authorization URL**: https://osdn.net/account/oauth2ui/authorize
- **Scopes**: 
  - profile: Read basic user profile
  - group: read access to group data
  - group_write: write access to group data
  - chamber: read access to chamber data
  - chamber_write: write access to chamber data

